/************************************************************************
	rgbled.h

    USB RGB Bargraph
    Copyright (C) 2010 Simon Inns

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

	Email: simon.inns@gmail.com

************************************************************************/

#ifndef RGBLED_H
#define RGBLED_H

// Structure for holding the RGB LED states
struct rgbLedState {
	// The target brightness levels
	int redTarget;
	int greenTarget;
	int blueTarget;
	
	// The current brightness levels
	int redActual;
	int greenActual;
	int blueActual;
	
	// The individual colour fade speed
	
	int redFadeSpeed;
	int greenFadeSpeed;
	int blueFadeSpeed;
	
	// Counters for timing the fade speed
	int redFadeCounter;
	int greenFadeCounter;
	int blueFadeCounter;
	
	// The fade on and off overall speed
	int fadeOnSpeed;
	int fadeOffSpeed;
};

struct displayState {
	struct rgbLedState rgbLed[16];
	int brightnessCounter;
} display;	

// Function prototypes
void setRgbLedColour(unsigned char rgbLedNumber, int red,
	int green, int blue);
void setRgbLedFadeSpeed(unsigned char rgbLedNumber, int fadeOn, int fadeOff);
void initialiseRgbDisplay(void);
void procesRgbLedBrightness(void);
	
#endif